"&"		{ return CAND; }
"|"		{ return COR; }
"("		{ return LPAREN; }
")"		{ return RPAREN; }
"{"		{ return LCURLY; }
"}"		{ return RCURLY; }
"["		{ return LBRACK; }
"]"		{ return RBRACK; }
"~"		{ return TILDE; }
"*"		{ return STAR; }
"**"		{ return EXP; }
"+"		{ return PLUS; }
"-"		{ return MINUS; }
"^"		{ return CARET; }
"\."		{ return DOT; }
"\.\.\."		{ return DOTS; }
","		{ return COMMA; }
"/"		{ return DIV; }
"//"		{ return MOD; }
"||"		{ return CONCAT; }
":"		{ return COLON; }
":="		{ return ASSIGN; }
"<"		{ return LT; }
"<="		{ return LE; }
"="		{ return EQ; }
"~="		{ return NEQ; }
">"		{ return GT; }
">="		{ return GE; }
[bB][eE][gG][iI][nN]		{ return BEGIN_; }
[bB][iI][nN][dD]		{ return BIND; }
[bB][rR][eE][aA][kK]		{ return BREAK; }
[cC][lL][aA][sS][sS]		{ return CLASS; }
[cC][oO][nN][sS][tT]"_"[iI][vV][aA][rR][sS]		{ return CONST_IVARS; }
[cC][oO][nN][tT][iI][nN][uU][eE]		{ return CONTINUE; }
[dD][oO]		{ return DO; }
[eE][lL][sS][eE]		{ return ELSE; }
[eE][lL][sS][eE][iI][fF]		{ return ELSEIF; }
[eE][nN][dD]		{ return END; }
[eE][xX][cC][eE][pP][tT]		{ return EXCEPT; }
[eE][xX][iI][tT]		{ return EXIT; }
[fF][aA][lL][sS][eE]		{ return FALSE_; }
[fF][oO][rR]		{ return FOR; }
[hH][aA][sS]		{ return HAS; }
[hH][iI][dD][eE][sS]		{ return HIDES; }
[iI][fF]		{ return IF; }
[iI][mM][pP][lL][eE][mM][eE][nN][tT][sS]		{ return IMPLEMENTS; }
[iI][nN]		{ return IN; }
[iI][nN][hH][eE][rR][iI][tT][sS]		{ return INHERITS; }
[iI][tT][eE][rR]		{ return ITER; }
[mM][aA][kK][eE]		{ return MAKE; }
[mM][aA][kK][eE][sS]		{ return MAKES; }
[mM][oO][dD][uU][lL][eE]		{ return MODULE; }
[nN][eE][wW]"_"[oO][bB][jJ][eE][cC][tT]		{ return NEWOBJECT; }
[nN][iI][lL]		{ return NIL; }
[oO][nN][eE][oO][fF]		{ return ONEOF; }
[oO][pP]		{ return OP; }
[oO][tT][hH][eE][rR][sS]		{ return OTHERS; }
[pP][rR][oO][cC]		{ return PROC; }
[pP][rR][oO][vV][iI][dD][eE][sS]		{ return PROVIDES; }
[rR][eE][cC][oO][rR][dD]		{ return RECORD; }
[rR][eE][sS][iI][gG][nN][aA][lL]		{ return RESIGNAL; }
[rR][eE][tT][uU][rR][nN]		{ return RETURN; }
[rR][eE][tT][uU][rR][nN][sS]		{ return RETURNS; }
[sS][eE][lL][fF]		{ return SELF; }
[sS][iI][gG][nN][aA][lL]		{ return SIGNAL; }
[sS][iI][gG][nN][aA][lL][sS]		{ return SIGNALS; }
[sS][tT][rR][uU][cC][tT]		{ return STRUCT; }
[tT][aA][gG][cC][aA][sS][eE]		{ return TAGCASE; }
[tT][hH][eE][nN]		{ return THEN; }
[tT][rR][uU][eE]		{ return TRUE_; }
[tT][yY][pP][eE]		{ return TYPE; }
[tT][yY][pP][eE][cC][aA][sS][eE]		{ return TYPECASE; }
[vV][aA][rR][iI][aA][nN][tT]		{ return VARIANT; }
[wW][hH][eE][nN]		{ return WHEN; }
[wW][hH][eE][rR][eE]		{ return WHERE; }
[wW][hH][iI][lL][eE]		{ return WHILE; }
[yY][iI][eE][lL][dD]		{ return YIELD; }
[yY][iI][eE][lL][dD][sS]		{ return YIELDS; }
